///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.ColorReducers;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ColorReducers
{
	public class SinAbsRepeater : RepeatedColorReducer<DummyScriptConfiguration>
	{
		public override string Description => "(2 * pi * rs * s1 + s2).Sin.Abs";

		protected override double ApplyUnitaryRepeater( IFluonContext fx, IFluonConfiguration fc, IColorReducerConfiguration crp, double x )
		{
			return (MathLib.Pi2 * x * crp.S1 + crp.S2).Sin().Abs();
		}
	}
}
