///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.DomainProjectors
{
	public class RadiusAsymptotic : DomainProjector<DummyScriptConfiguration>
	{
		public override string Description => "x.Radius = rp / (s2 + rp); rp = x.r ^ s1";

		public override Mdn Project( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			var rp = x.ra.PowA( fc.DomainProjectorS1 );

			x.RadiusA = rp / (fc.DomainProjectorS2 + rp);

			return x;
		}
	}
}
