///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.Contexts;
using Fluogen.Dependz.FluonGenerators;
using Got.Libraries;

namespace Fluogen.DeployedScripts.FluonGenerators
{
	public class Matrix117Billion : IteratedFluonGeneratorWithSingleDomain<DummyScriptConfiguration, DummyCarryState>
	{
		protected override Mdn ProcessCodomainIteration( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y
			, ref DummyCarryState carryState )
		{
			Mdn m1 = fc.FluonGeneratorM1;

			double t0 = (y[ 0 ].Sqr() - y[ 1 ].Sqr()).Sin() - y[ 0 ] + x[ 0 ] + m1[ 0 ];
			double t1 = 2 * y[ 0 ] * y[ 1 ] + y[ 1 ] + x[ 1 ] + m1[ 1 ];
			double t2 = y.CartesiansSum() + x[ 2 ] + m1[ 2 ];

			return new Mdn( new double[] { t0, t1, t2 } );
		}
	}
}
