///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.Contexts;
using Fluogen.Dependz.FluonGenerators;
using Got.Libraries;

namespace Fluogen.DeployedScripts.FluonGenerators
{
	public class MandelbrotQuaternions : IteratedFluonGeneratorWithSingleDomain<DummyScriptConfiguration, DummyCarryState>
	{
		protected override Mdn InitializeCodomain( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			return fc.FluonGeneratorM1;
		}

		public override void Validate( IFluonConfiguration fc )
		{
			base.Validate( fc );

			if( fc.FluonGeneratorS1 < 2 || !fc.FluonGeneratorS1.IsInteger() )
				throw new ArgumentException( $"{nameof( MandelbrotQuaternions )}:"
					+ $" FluonGeneratorS1 < 2 || !IsInteger( FluonGeneratorS1 )" );
		}

		protected override Mdn ProcessCodomainIteration( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y
			, ref DummyCarryState carryState )
		{
			var t = new MdnPlay( y );

			for( int i = 1; i < fc.FluonGeneratorS1; i++ )
				t = t.HamiltonMul( t );

			return (Mdn)t + x;
		}
	}
}
