///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.MdnEscapers
{
	public class RadiusAbs : MdnEscaper<DummyScriptConfiguration>
	{
		public override string Description => "ev >= et; ev = y.r";

		public override void Validate( IFluonConfiguration fc )
		{
			base.Validate( fc );

			if( fc.EscapeThreshold <= 0 )
				throw new ArgumentException( $"{nameof( RadiusAbs )}: EscapeThreshold <= 0" );
		}

		public override bool HasEscaped( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y, Mdn yp, double evp
			, int ri, out double ev )
		{
			ev = y.RadiusA;

			return ev >= fc.EscapeThreshold;
		}
	}
}
