///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Fluogen.DeployedScripts.Libraries;

// #lib PaletteToneExtensions

namespace Fluogen.DeployedScripts.Palettes
{
	public class CaramelLava : BitonalGradientPalette<DummyScriptConfiguration>
	{
		protected override IPaletteConfiguration GetPaletteConfiguration( IFluonConfiguration fc )
		{
			var configuration = base.GetPaletteConfiguration( fc );

			configuration.PaletteVariant = PaletteVariant.CaramelLava;

			return configuration;
		}

		protected override IBitonalGradientPaletteConfiguration GetSpecificConfiguration( IFluonConfiguration fc
			, IPaletteContext paletteContext )
		{
			var configuration = base.GetSpecificConfiguration( fc, paletteContext );

			var colorModel = paletteContext.OC.ColorModel.Value;

			configuration.RubyTone1( colorModel );
			configuration.CaramelTone2( colorModel );

			return configuration;
		}
	}
}
