///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;

namespace Fluogen.DeployedScripts.Palettes
{
	public class RainbowRgb : Palette<DummyScriptConfiguration>
	{
		public override int FullSize => 1280;
		public override int QuickSize => FullSize;

		protected override void InitializeCache( IFluonConfiguration fc )
		{
		}

		protected override IList<PixelRgbColor> CacheColors()
		{
			var colors = new PixelRgbColor[ FullSize ];

			for( int i = 0; i < 256; i++ )
			{
				colors[ i ] = PixelRgbColor.FromRgb8Bits( (byte)i, 0, 0 );
				colors[ i + 256 ] = PixelRgbColor.FromRgb8Bits( 255, (byte)i, 0 );
				colors[ i + 512 ] = PixelRgbColor.FromRgb8Bits( (byte)(255 - i), 255, (byte)i );
				colors[ i + 768 ] = PixelRgbColor.FromRgb8Bits( (byte)i, (byte)(255 - i), 255 );
				colors[ i + 1024 ] = PixelRgbColor.FromRgb8Bits( (byte)(255 - i), 0, (byte)(255 - i) );
			}

			return colors;
		}

		protected override PixelRgbColor ComputeColor( IFluonConfiguration fc, double scalar )
		{
			throw new InvalidOperationException();
		}
	}
}
