///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;

namespace Fluogen.DeployedScripts.Palettes
{
	public class TestHcjMarkList : MonotoneCubicGradientPalette<DummyScriptConfiguration>
	{
		protected int H => 8000;
		protected int C => 2000;

		protected override IGradientPaletteMarkList GetMarks( IFluonConfiguration fc )
		{
			int hue1 = fc.BitonalGradientPaletteOverridingConfiguration.ToneHue1 != null
				? fc.BitonalGradientPaletteOverridingConfiguration.ToneHue1.Value : H;
			int hue2 = fc.BitonalGradientPaletteOverridingConfiguration.ToneHue2 != null
				? fc.BitonalGradientPaletteOverridingConfiguration.ToneHue2.Value : H;

			return new GradientPaletteMarkList
			{
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.000,  2000, 10000,  0, ColorModelName.Hcj, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.020,  2000,  1000, 96, ColorModelName.Hcj, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.100,  2000,  1000,   320, ColorModelName.Hcj, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.200,  2000,  1000,   440, ColorModelName.Hcj, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.500,  1200, 10000, 10000, ColorModelName.Hcj, true ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.600,  7250, 10000,   560, ColorModelName.Hcj, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.700,  7250, 10000,   360, ColorModelName.Hcj, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.850,  7250,  1800,   160, ColorModelName.Hcj, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 1.000,  7250, 10000,  0, ColorModelName.Hcj, false ),

				//?GetMarkFromTypeableHsl( 0.00,  hue1, C,  0, ColorModelName.Hcj, false ),
				//GetMarkFromTypeableHsl( 0.10,  hue1, C, 91, ColorModelName.Hcj, false ),
				//GetMarkFromTypeableHsl( 0.20,  hue1, C,   149, ColorModelName.Hcj, false ),
				//GetMarkFromTypeableHsl( 0.35,  hue1, C,   264, ColorModelName.Hcj, false ),
				//GetMarkFromTypeableHsl( 0.50,  hue1, C,   782, ColorModelName.Hcj, false ),
				//GetMarkFromTypeableHsl( 0.65,  hue1, C,   264, ColorModelName.Hcj, false ),
				//GetMarkFromTypeableHsl( 0.80,  hue1, C,   149, ColorModelName.Hcj, false ),
				//GetMarkFromTypeableHsl( 0.90,  hue1, C, 91, ColorModelName.Hcj, false ),
				//GetMarkFromTypeableHsl( 1.00,  hue1, C,  0, ColorModelName.Hcj, false )
			};
		}
	}
}
