///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ScalarReducers
{
	public class LoopLnAbs : ScalarReducer<DummyScriptConfiguration>
	{
		public override string Description => "|a|.LoopLn( s1 )";

		public override void Validate( IFluonConfiguration fc )
		{
			base.Validate( fc );

			if( fc.ScalarReducerS1 <= 0 || !fc.ScalarReducerS1.IsInteger() )
				throw new ArgumentException( $"{nameof( LoopLnAbs )}: ScalarReducerS1 <= 0 || !IsInteger( ScalarReducerS1 )" );
		}

		public override ColorDeterminant Reduce( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, ColorDeterminant a )
		{
			int count = (int)fc.ScalarReducerS1;

			return a.Replace( a.Main.LoopLnA( count ) );
		}
	}
}
