///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ScalarReducers
{
	public class PhiAlways : ScalarReducer<DummyScriptConfiguration>
	{
		public override string Description => "a.PhiAlways( s1 ); PhiAlways = a >= 0 ? (s1 ^ 2 / (a + |s1|)) : (s1 ^ 2 / (a - |s1|))";

		public override void Validate( IFluonConfiguration fc )
		{
			base.Validate( fc );

			if( fc.ScalarReducerS1.IsZeroWithinEps() )
				throw new ArgumentException( $"{nameof( PhiAlways )}: Limit == 0" );
		}

		public override ColorDeterminant Reduce( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, ColorDeterminant a )
		{
			return a.Replace( a.Main.PhiAlways( fc.ScalarReducerS1 ) );
		}
	}
}
